<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="mod_log_config － Apache 2.2 中文手册 [金步国作品集]">
<title>mod_log_config － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>Apache模块 mod_log_config</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>允许记录日志和定制日志文件格式</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">模块名</a></th><td>log_config_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">源文件</a></th><td>mod_log_config.c</td></tr>
</table>
<h3>概述</h3>

    <p>本模块提供了灵活的方法将客户请求记录到日志。日志可以用自定义的格式直接写入文件，或者传送到一个外部程序继续处理。条件日志功能可以实现根据请求的特征来决定一个日志信息是否被包含在最终的日志记录里面。</p>

    <p>本模块提供了三个指令：<code class="directive"><a href="#transferlog">TransferLog</a></code>指令用来指定日志文件，<code class="directive"><a href="#logformat">LogFormat</a></code>指令用来定义日志格式，<code class="directive"><a href="#customlog">CustomLog</a></code>指令可以同时完成指定日志文件和定义日志格式。<code class="directive">TransferLog</code>和<code class="directive">CustomLog</code>指令在每个服务器上都可以被多次使用，以便将同一个请求记录到多个文件中。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="formats" id="formats">定制日志文件格式</a></h2>

    <p><code class="directive"><a href="#logformat">LogFormat</a></code>和<code class="directive"><a href="#customlog">CustomLog</a></code>指令的格式化参数是一个字符串。这个字符串会在每次请求发生的时候，被记录到日志中去。它可以包含将被原样写入日志的文本字符串以及C风格的控制字符"\n"和"\t"以实现换行与制表。文本中的引号和反斜杠应通过"\"来转义。</p>

    <p>请求本身的情况将通过在格式字符串中放置各种"<code>%</code>"转义符的方法来记录，它们在写入日志文件时，根据下表的定义进行转换：</p>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="bordered">
<tr class="header"><th>格式字符串</th><th>描述</th></tr>
<tr><td><code>%%</code></td><td>百分号(<em>Apache2.0.44或更高的版本</em>)</td></tr>
<tr class="odd"><td><code>%a</code></td><td>远端IP地址</td></tr>
<tr><td><code>%A</code></td><td>本机IP地址</td></tr>
<tr class="odd"><td><code>%B</code></td><td>除HTTP头以外传送的字节数</td></tr>
<tr><td><code>%b</code></td><td>以CLF格式显示的除HTTP头以外传送的字节数，也就是当没有字节传送时显示'<code>-</code>'而不是0。</td></tr>
<tr class="odd"><td><code>%{<var>Foobar</var>}C</code></td><td>在请求中传送给服务端的cookie<var>Foobar</var>的内容。</td></tr>
<tr><td><code>%D</code></td><td>服务器处理本请求所用时间，以微为单位。</td></tr>
<tr class="odd"><td><code>%{<var>FOOBAR</var>}e</code></td><td>环境变量<var>FOOBAR</var>的值</td></tr>
<tr><td><code>%f</code></td><td>文件名</td></tr>
<tr class="odd"><td><code>%h</code></td><td>远端主机</td></tr>
<tr><td><code>%H</code></td><td>请求使用的协议</td></tr>
<tr class="odd"><td><code>%{<var>Foobar</var>}i</code></td><td>发送到服务器的请求头<code><var>Foobar:</var></code>的内容。</td></tr>
<tr><td><code>%l</code></td><td>远端登录名(由identd而来，如果支持的话)，除非<code class="directive"><a href="../mod/core.html#identitycheck">IdentityCheck</a></code>设为&quot;<code>On</code>&quot;，否则将得到一个&quot;-&quot;。</td></tr>
<tr class="odd"><td><code>%m</code></td><td>请求的方法</td></tr>
<tr><td><code>%{<var>Foobar</var>}n</code></td><td>来自另一个模块的注解<code><var>Foobar</var></code>的内容。</td></tr>
<tr class="odd"><td><code>%{<var>Foobar</var>}o</code></td><td>应答头<code><var>Foobar</var>:</code>的内容。</td></tr>
<tr><td><code>%p</code></td><td>服务器服务于该请求的标准端口。</td></tr>
<tr class="odd"><td><code>%P</code></td><td>为本请求提供服务的子进程的PID。</td></tr>
<tr><td><code>%{<var>format</var>}P</code></td><td>服务于该请求的PID或TID(线程ID)，<code><var>format</var></code>的取值范围为：<code>pid</code>和<code>tid</code>(<em>2.0.46及以后版本</em>)以及<code>hextid</code>(需要APR1.2.0及以上版本)</td></tr>
<tr class="odd"><td><code>%q</code></td><td>查询字符串(若存在则由一个&quot;<code>?</code>&quot;引导，否则返回空串)</td></tr>
<tr><td><code>%r</code></td><td class="odd">请求的第一行</td></tr>
<tr class="odd"><td><code>%s</code></td><td>状态。对于内部重定向的请求，这个状态指的是<em>原始</em>请求的状态，---<code>%&gt;s</code>则指的是最后请求的状态。</td></tr>
<tr><td><code>%t</code></td><td class="odd">时间，用普通日志时间格式(标准英语格式)</td></tr>
<tr class="odd"><td><code>%{<var>format</var>}t</code></td><td>时间，用<code>strftime(3)</code>指定的格式表示的时间。(默认情况下按本地化格式)</td></tr>
<tr><td><code>%T</code></td><td class="odd">处理完请求所花时间，以秒为单位。</td></tr>
<tr class="odd"><td><code>%u</code></td><td>远程用户名(根据验证信息而来；如果返回status(<code>%s</code>)为401，可能是假的)</td></tr>
<tr><td><code>%U</code></td><td class="odd">请求的URL路径，不包含查询字符串。</td></tr>
<tr class="odd"><td><code>%v</code></td><td>对该请求提供服务的标准<code class="directive"><a href="../mod/core.html#servername">ServerName</a></code>。</td></tr>
<tr><td><code>%V</code></td><td class="odd">根据<code class="directive"><a href="../mod/core.html#usecanonicalname">UseCanonicalName</a></code>指令设定的服务器名称。</td></tr>
<tr class="odd"><td><code>%X</code></td><td>请求完成时的连接状态：<table border="1" cellpadding="0" cellspacing="0" bordercolor="#CCCCCC">
<tr><td><code>X</code>=</td><td>连接在应答完成前中断。</td></tr>
<tr><td><code>+</code>=</td><td>应答传送完后继续保持连接。</td></tr>
<tr><td><code>-</code>=</td><td>应答传送完后关闭连接。</td></tr>
</table><p>(在1.3以后的版本中，这个指令是<code>%c</code>，但这样就和过去的SSL语法：<code>%{<var>var</var>}c</code>冲突了)</p></td></tr>
<tr><td><code>%I</code></td><td class="odd">接收的字节数，包括请求头的数据，并且不能为零。要使用这个指令你必须启用<code class="module"><a href="../mod/mod_logio.html">mod_logio</a></code>模块。</td></tr>
<tr class="odd"><td><code>%O</code></td><td>发送的字节数，包括请求头的数据，并且不能为零。要使用这个指令你必须启用<code class="module"><a href="../mod/mod_logio.html">mod_logio</a></code>模块。</td></tr>
</table>

    <h3><a name="modifiers" id="modifiers">修饰符</a></h3>

      <p>可以紧跟在"%"后面加上一个逗号分隔的状态码列表来限制记录的条目。例如，"<code>%400,501{User-agent}i</code>"只记录状态码400和501发生时的<code>User-agent</code>头内容；不满足条件时用"<code>-</code>"代替。状态码前还可以加上"<code>!</code>"前缀表示否定，"<code>%!200,304,302{Referer}i</code>"记录所有<em>不同于</em>200,304,302的状态码发生时的<code>Referer</code>头内容。</p>

      <p>"&lt;"和"&gt;"修饰符可以用来指定对于已被内部重定向的请求是选择原始的请求还是选择最终的请求。默认情况下，<code>%s, %U, %T, %D, %r</code> 使用原始请求，而所有其他格式串则选择最终请求。例如，<code>%&gt;s</code> 可以用于记录请求的最终状态，而 <code>%&lt;u</code> 则记录一个已经被内部重定向到非认证资源的请求的原始认证用户。</p>



    <h3><a name="format-notes" id="format-notes">一些说明</a></h3>

      <p>出于安全考虑，从2.0.46版本开始，<code>%r</code>, <code>%i</code>, <code>%o</code> 中的特殊字符，除了双引号(")和反斜线(\)分别用 <code>\"</code> 和 <code>\\</code> 进行转义、空白字符用C风格(<code>\n</code>, <code>\t</code> 等)进行转义以外，非打印字符和其它特殊字符使用 <code>\x<var>hh</var></code> 格式进行转义(<var>hh</var>是该字符的16进制编码)。在2.0.46以前的版本中，这些内容会被完整的按原样记录。这种做法将导致客户端可以在日志中插入控制字符，所以你在处理这些日志文件的时候要特别小心。</p>

      <p>在2.0版本中(不同于1.3)，<code>%b</code> 和 <code>%B</code> 格式字符串并不表示发送到客户端的字节数，而只是简单的表示HTTP应答字节数(在连接中断或使用SSL时与前者有所不同)。<code class="module"><a href="../mod/mod_logio.html">mod_logio</a></code>提供的 <code>%O</code> 格式字符串将会记录发送的实际字节数。</p>



    <h3><a name="examples" id="examples">示例</a></h3>

      <p>一些常见的格式串：</p>

      <dl>
        <dt>通用日志格式(CLF)</dt>
        <dd><code>"%h %l %u %t \"%r\" %&gt;s %b"</code></dd>

        <dt>带虚拟主机的通用日志格式</dt>
        <dd><code>"%v %h %l %u %t \"%r\" %&gt;s %b"</code></dd>

        <dt>NCSA扩展/组合日志格式</dt>
        <dd><code>"%h %l %u %t \"%r\" %&gt;s %b \"%{Referer}i\" \"%{User-agent}i\""</code></dd>

        <dt>Referer日志格式</dt>
        <dd><code>"%{Referer}i -&gt; %U"</code></dd>

        <dt>Agent(Browser)日志格式</dt>
        <dd><code>"%{User-agent}i"</code></dd>
      </dl>

</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="security" id="security">安全考虑</a></h2>
    <p>如果放置日志文件的目录对除启动Apache服务以外的其他用户可写，可能会对系统的安全性造成威胁，具体的讨论请参见<a href="../misc/security_tips.html#serverroot">安全方面的提示</a>。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="BufferedLogs" id="BufferedLogs">BufferedLogs</a> <a name="bufferedlogs" id="bufferedlogs">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>在将日志写入磁盘前先在内存中进行缓冲</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>BufferedLogs On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>BufferedLogs Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_log_config</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.0.41 及以后的版本中可用</td></tr>
</table>
    <p><code class="directive">BufferedLogs</code>指令使得<code class="module"><a href="../mod/mod_log_config.html">mod_log_config</a></code>先在内存中缓冲一些日志内容，然后一次性写入磁盘，而不是立即写入。在一些系统上这样做可以提高磁盘性能。这个设置仅能够针对全局进行设置，不能单独针对虚拟主机进行设置。</p>

    <div class="note">这是一个试验性的指令，请在使用中多加小心。</div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="CookieLog" id="CookieLog">CookieLog</a> <a name="cookielog" id="cookielog">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>设定针对cookies的日志文件名</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>CookieLog <var>filename</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_log_config</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>反对使用该指令</td></tr>
</table>
    <p><code class="directive">CookieLog</code>指令使用cookies作为日志文件名。文件是相对于<code class="directive"><a href="../mod/core.html#serverroot">ServerRoot</a></code>目录的。包含本指令仅仅是为了保持与<code>mod_cookies</code>模块的兼容，并且反对使用。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="CustomLog" id="CustomLog">CustomLog</a> <a name="customlog" id="customlog">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>设定日志的文件名和格式</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>CustomLog  <var>file</var>|<var>pipe</var> <var>format</var>|<var>nickname</var> [env=[!]<var>environment-variable</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_log_config</td></tr>
</table>
    <p><code class="directive">CustomLog</code>指令用来对服务器的请求进行日志记录。可以指定日志的格式，也可以使用环境变量根据请求的特征来自由地组织日志。</p>

    <p>第一个参数指定了日志记录的位置，可以使用以下两种方式来设定：</p>

    <dl>
      <dt><var>file</var></dt>
      <dd>相对于<code class="directive"><a href="../mod/core.html#serverroot">ServerRoot</a></code>的日志文件名。</dd>

      <dt><var>pipe</var></dt>
      <dd>管道符"<code>|</code>"后面紧跟着一个把日志输出当作标准输入的处理程序路径。
      <div class="warning"><h3>安全</h3>
      <p>如果这里用到了程序，那么这个程序是以启动<code class="program"><a href="../programs/httpd.html">httpd</a></code>的用户来执行的。因此如果启动httpd的用户是root ，那这个程序也将以root身份来运行；你需要确认这个程序是安全的。</p>
      </div>
      <div class="warning"><h3>注意</h3>
        <p>当在非UNIX平台上输入文件路径的时候，要特别注意即使平台本身是使用反斜杠(\)来分隔路径的，在这里也只能使用正斜杠(/)。通常在配置文件里只用正斜杠(/)来分隔路径总是不会错的。</p>
      </div></dd>
    </dl>

    <p>第二个参数指定了写入日志文件的内容。它既可以是由前面的<code class="directive"><a href="#logformat">LogFormat</a></code>指令定义的<var>nickname</var> ，也可以是直接按<a href="#formats">日志格式</a>一节所描述的规则定义的<var>format</var>字符串。</p>

    <p>例如：以下两组指令的结果是完全一样的：</p>

    <div class="example"><p><code>
      # 使用nickname<br />
      LogFormat "%h %l %u %t \"%r\" %&gt;s %b" common<br />
      CustomLog logs/access_log common<br />
      <br />
      # 明确使用格式格式字符串<br />
      CustomLog logs/access_log "%h %l %u %t \"%r\" %&gt;s %b"
    </code></p></div>

    <p>第三个参数是可选的，它根据服务器上特定的环境变量是否被设置来决定是否对某一特定的请求进行日志记录。如果这个特定的<a href="../env.html">环境变量</a>被设置(或者在"<code>env=!<var>name</var></code>"的情况下未被设置)，那么这个请求将被记录。</p>

    <p>可以使用<code class="module"><a href="../mod/mod_setenvif.html">mod_setenvif</a></code>和/或<code class="module"><a href="../mod/mod_rewrite.html">mod_rewrite</a></code>模块来为每个请求设置环境变量。例如：如果你想在服务器上将所有对GIF图片的请求记录在不同于主日志文件的另一个日志文件中，你可以使用下面的指令：</p>

    <div class="example"><p><code>
      SetEnvIf Request_URI \.gif$ gif-image<br />
      CustomLog gif-requests.log common env=gif-image<br />
      CustomLog nongif-requests.log common env=!gif-image
    </code></p></div>

    <p>或者为了复制旧有的RefererIgnore指令的行为，你可以使用下面的指令：</p>

    <div class="example"><p><code>
    SetEnvIf Referer example\.com localreferer<br />
    CustomLog referer.log referer env=!localreferer
    </code></p></div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="LogFormat" id="LogFormat">LogFormat</a> <a name="logformat" id="logformat">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>定义访问日志的记录格式</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>LogFormat <var>format</var>|<var>nickname</var> [<var>nickname</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>LogFormat "%h %l %u %t \"%r\" %&gt;s %b"</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_log_config</td></tr>
</table>
    <p>本指令定义访问日志的记录格式。</p>

    <p><code class="directive">LogFormat</code>指令可以使用两种定义格式中的一种。在第一种格式中，指令只带一个参数，以定义后续的<code class="directive">TransferLog</code>指令定义的日志格式。这个唯一的参数可以按上述<a href="#formats">自定义日志格式</a>小节所描述的<var>format</var>来定义。另外它也可以通过下述的方法使用<var>nickname</var>来引用某个之前的<code class="directive">LogFormat</code>定义的日志格式。</p>

    <p>第二种定义<code class="directive">LogFormat</code>指令的格式中，将一个直接的<var>format</var>和一个<var>nickname</var>联系起来。这样在后续的<code class="directive">LogFormat</code>或<code class="directive"><a href="#customlog">CustomLog</a></code>指令中，就不用一再重复整个冗长的格式串。定义别名的<code class="directive">LogFormat</code>指令仅仅用来定义一个<var>nickname</var> ，而<strong>不做其它任何事情</strong>：也就是说，它<em>只是</em>定义了这个别名，它既没有实际应用这个别名，也不是把它设为默认的格式。因此，它不会影响后续的<code class="directive"><a href="#transferlog">TransferLog</a></code>指令。另外，<code class="directive">LogFormat</code>不能用一个别名来定义另一个别名。注意，别名不能包含百分号(<code>%</code>)。</p>

    <div class="example"><h3>示例</h3><p><code>
      LogFormat "%v %h %l %u %t \"%r\" %&gt;s %b" vhost_common
    </code></p></div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="TransferLog" id="TransferLog">TransferLog</a> <a name="transferlog" id="transferlog">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>指定日志文件的位置</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>TransferLog <var>file</var>|<var>pipe</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_log_config</td></tr>
</table>
    <p>本指令除不允许直接定义日志格式或根据条件进行日志记录外，与<code class="directive"><a href="#customlog">CustomLog</a></code>指令有完全相同的参数和功能。实际应用中，日志的格式是由最近的非别名定义的<code class="directive"><a href="#logformat">LogFormat</a></code>指令指定。如果没有定义任何日志格式，则使用通用日志格式。</p>

    <div class="example"><h3>示例</h3><p><code>
      LogFormat "%h %l %u %t \"%r\" %&gt;s %b \"%{Referer}i\" \"%{User-agent}i\""<br />
      TransferLog logs/access_log
    </code></p></div>

</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
